// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from automotive_platform_msgs:msg/AdaptiveCruiseControlCommand.idl
// generated code does not contain a copyright notice
#include "automotive_platform_msgs/msg/detail/adaptive_cruise_control_command__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__init(automotive_platform_msgs__msg__AdaptiveCruiseControlCommand * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__fini(msg);
    return false;
  }
  // msg_counter
  // set_speed
  // set
  // resume
  // cancel
  // speed_up
  // slow_down
  // further
  // closer
  return true;
}

void
automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__fini(automotive_platform_msgs__msg__AdaptiveCruiseControlCommand * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // msg_counter
  // set_speed
  // set
  // resume
  // cancel
  // speed_up
  // slow_down
  // further
  // closer
}

bool
automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__are_equal(const automotive_platform_msgs__msg__AdaptiveCruiseControlCommand * lhs, const automotive_platform_msgs__msg__AdaptiveCruiseControlCommand * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // msg_counter
  if (lhs->msg_counter != rhs->msg_counter) {
    return false;
  }
  // set_speed
  if (lhs->set_speed != rhs->set_speed) {
    return false;
  }
  // set
  if (lhs->set != rhs->set) {
    return false;
  }
  // resume
  if (lhs->resume != rhs->resume) {
    return false;
  }
  // cancel
  if (lhs->cancel != rhs->cancel) {
    return false;
  }
  // speed_up
  if (lhs->speed_up != rhs->speed_up) {
    return false;
  }
  // slow_down
  if (lhs->slow_down != rhs->slow_down) {
    return false;
  }
  // further
  if (lhs->further != rhs->further) {
    return false;
  }
  // closer
  if (lhs->closer != rhs->closer) {
    return false;
  }
  return true;
}

bool
automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__copy(
  const automotive_platform_msgs__msg__AdaptiveCruiseControlCommand * input,
  automotive_platform_msgs__msg__AdaptiveCruiseControlCommand * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // msg_counter
  output->msg_counter = input->msg_counter;
  // set_speed
  output->set_speed = input->set_speed;
  // set
  output->set = input->set;
  // resume
  output->resume = input->resume;
  // cancel
  output->cancel = input->cancel;
  // speed_up
  output->speed_up = input->speed_up;
  // slow_down
  output->slow_down = input->slow_down;
  // further
  output->further = input->further;
  // closer
  output->closer = input->closer;
  return true;
}

automotive_platform_msgs__msg__AdaptiveCruiseControlCommand *
automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_platform_msgs__msg__AdaptiveCruiseControlCommand * msg = (automotive_platform_msgs__msg__AdaptiveCruiseControlCommand *)allocator.allocate(sizeof(automotive_platform_msgs__msg__AdaptiveCruiseControlCommand), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(automotive_platform_msgs__msg__AdaptiveCruiseControlCommand));
  bool success = automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__destroy(automotive_platform_msgs__msg__AdaptiveCruiseControlCommand * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__Sequence__init(automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_platform_msgs__msg__AdaptiveCruiseControlCommand * data = NULL;

  if (size) {
    data = (automotive_platform_msgs__msg__AdaptiveCruiseControlCommand *)allocator.zero_allocate(size, sizeof(automotive_platform_msgs__msg__AdaptiveCruiseControlCommand), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__Sequence__fini(automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__Sequence *
automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__Sequence * array = (automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__Sequence *)allocator.allocate(sizeof(automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__Sequence__destroy(automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__Sequence__are_equal(const automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__Sequence * lhs, const automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__Sequence__copy(
  const automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__Sequence * input,
  automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(automotive_platform_msgs__msg__AdaptiveCruiseControlCommand);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    automotive_platform_msgs__msg__AdaptiveCruiseControlCommand * data =
      (automotive_platform_msgs__msg__AdaptiveCruiseControlCommand *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!automotive_platform_msgs__msg__AdaptiveCruiseControlCommand__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
